// Some 3D graphics sample

#include "hmg.ch"

#define VALAUTO 0.03
#define DELAY 0.6
#define WSAEWOULDBLOCK 10035

#define VIOLETA { 153,    0,  153 }
#define ORANGE  { 225,  117,   54 }

Function Main()

   REQUEST DBFNTX
   RDDSETDEFAULT( "DBFNTX" )
   SET TOOLTIPSTYLE BALLOON
   SET TOOLTIPBACKCOLOR { 255 , 255, 0 }
   SET DATE BRITISH
   SET CENTURY ON
   SET CODEPAGE TO SPANISH
   SET DELETED OFF

   Publicar()

   DEFINE WINDOW oaSSisCajaA ;
	AT nRow, nCol ;
	WIDTH nWidth ;
	HEIGHT nHeight ; 
	TITLE "GAME - HMG 3.4.4 - CopyR 2017 Ing. Oscar A. Salinas - * ID. Program 01-2017-0916-0370 * -" ; 
	FONT "TAHOMA" SIZE 10 ;
        NOSIZE ;
        NOMAXIMIZE ;
        ON PAINT Pintar() ;
        MAIN

	ON KEY ESCAPE ACTION oaSSisCajaA.Release
	ON KEY LEFT   ACTION {|| Der := .F., iif(Yoff-9 < 180, Yoff:=180, Yoff -= 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	ON KEY RIGHT  ACTION {|| Der := .T., iif(Yoff+9 > nWidth-23, Yoff:=180, Yoff += 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	ON KEY DOWN   ACTION {|| iif(Xoff+9 > nHeight-53, Xoff:= 24, Xoff += 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	ON KEY UP     ACTION {|| iif(Xoff-9 < 24, Xoff:= nHeight-52, Xoff -= 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}

        DEFINE BUTTON BotInicio
        ROW   10
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Iniciar"
        action (oaSSisCajaA.TimerRelojA.Enabled := .T.)
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotDerecha
        ROW   10
        COL    110
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Derecha"
        action {|| Der := .T.,  iif(Yoff+9 > nWidth-23, Yoff:=180, Yoff += 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotIzquierda
        ROW   31
        COL    110
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Izquierda"
        action {|| Der := .F., iif(Yoff-9 < 180, Yoff:=180, Yoff -= 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotRotay
        ROW   52
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Rotar Eje Y"
        action {|| iif(yAn<=5.97, yAn+=0.30, Yan:=0), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotRotax
        ROW   73
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Rotar Eje X"
        action {|| iif(xAn<=5.96, xAn+=0.30, xAn:=0), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotRotaz
        ROW   94
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Rotar Eje Z"
        action {|| iif(zAn<=5.96, zAn+=0.30, zAn:=0), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotAbajo
        ROW   52
        COL    110
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Abajo"
        action {|| iif(Xoff+9 > nHeight-53, Xoff:= 24, Xoff += 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotArriba
        ROW    73
        COL    110
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Arriba"
        action {|| iif(Xoff-9 < 24, Xoff:= nHeight-52, Xoff -= 9), BT_ClientAreaInvalidateAll ("oaSSisCajaA")}
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotTest1
        ROW   160
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Test 1"
        action Test1()
	MULTILINE .F.
        END BUTTON

        DEFINE BUTTON BotTest2
        ROW   183
        COL    5
        WIDTH  100
        HEIGHT  20
	FONTNAME "Comic Sans MS"
	FONTSIZE 9
        CAPTION "Test 2"
        action Test2()
	MULTILINE .F.
        END BUTTON

        DEFINE TIMER TimerRelojA ;
           PARENT    oaSSisCajaA ;
           INTERVAL  125 ;
	   ACTION    {||iif(Der,(iif(yAn<=5.96, yAn+=0.30, Yan:=0), ;
                                 iif(zAn<=5.96, zAn+=0.30, zAn:=0), ;
                                 iif(xAn<=5.96, xAn+=0.30, xAn:=0), ;
                                 iif(Yoff+9 > nWidth-23, Yoff:=180,Yoff+=9)),;
				(iif(yAn>0.31, yAn-=0.30, Yan:=5.96), ;
                                 iif(zAn>=0.31, zAn-=0.30, zAn:=5.96), ;
                                 iif(xAn>=0.31, xAn+=0.30, xAn:=5.96), ;
                                 iif(Yoff-9 < 180,Yoff:=180,Yoff-=9))),;
                                 BT_ClientAreaInvalidateAll ("oaSSisCajaA")}

   END WINDOW

   oaSSisCajaA.TimerRelojA.Enabled := .F.

   oaSSisCajaA.Activate

Return Nil
*************************
*
*************************
Procedure Publicar()

    Public nAltoPantalla  := GetDesktopHeight() + GetTitleHeight() + GetBorderHeight()
    Public nAnchoPantalla := GetDesktopWidth()
    Public nRow           := nAltoPantalla  * 0.01
    Public nCol           := nAnchoPantalla * 0.02
    Public nWidth         := nAnchoPantalla * 0.97
    Public nHeight        := nAltoPantalla  * 0.91
    Public VERSION        := " Version 1.0 - 2017 Beta "
    Public _RutaProg      := GetStartUpFolder() + '\'
    Public aVector_3d
    Public aFaces
    Public nFaces
    Public aPaintList
    Public aRVectors
    Public aCoords_2d
    Public nVertex_per_face
    Public lStop           := .F.
    Public yAn
    Public syAn
    Public cYan             // Angles
    Public xAn
    Public sXAn
    Public cXan             //   ""    (los 3 en radianes)
    Public zAn
    Public szAn
    Public cZan             //   ""
    Public Der := .T.    
    Public sZoff                      // Desplazamiento inicial Z
    Public sXoff                      // Desplazamineto inicial X (las 3 2d)
    Public sYoff                      // Desplazamineto inicial Y

    Public Zoff                       // desplazamineto de z
    Public Xoff                       // desplazamineto de x
    Public Yoff                       // desplazamineto de y

    Public AutoRotX                // .F./.T. al Rot de x
    Public AutoRotY                // .F./.T. al Rot de y
    Public AutoRotZ                // .F./.T. al Rot de z

    Public RotX                    // add to xAn
    Public RotY                    // add to yAn
    Public RotZ                    // add to zAn

    Newo1()

Return
**********************
*
**********************
Function GradToRad(grados)
Return (Grados*3.1416)/180
**********************
*
**********************
Function Test1()

   Newo1() 

   BT_ClientAreaInvalidateAll ("oaSSisCajaA")

Return Nil
**********************
*
**********************
Function Test2()

   Newo2()

   BT_ClientAreaInvalidateAll ("oaSSisCajaA")

Return Nil
**********************
*
**********************
Function Init_Data()

	nFaces := Len(aFaces)
	aPaintList := Array(nFaces)

	aRVectors  := Array(Len(aVector_3d),3)
	aCoords_2d := Array(Len(aVector_3d),2)
	nVertex_per_face := Len(aFaces[1])

Return  Nil
**********************
*
**********************
Procedure Pintar()
LOCAL ssWidth  := BT_ClientAreaWidth  ("oaSSisCajaA") 
LOCAL ssHeight := BT_ClientAreaHeight ("oaSSisCajaA")
Local Cardena1, Cardena2, Cardena3, Cardena4
Local Linea, Lapiz, Llena
LOCAL hDC, BTstruct

  hDC := BT_CreateDC ("oaSSisCajaA", BT_HDC_INVALIDCLIENTAREA, @BTstruct)

  BT_DrawGradientFillVertical (hDC,  0,  0,  ssWidth,  ssHeight, WHITE, BLUE)                 


  SinCosS()

  For T=1 to Len(aVector_3d)
     de_3d_a_2d(aVector_3d[T],aCoords_2d[T],aRVectors[T])
  Next

  Ordena_Z()

  Cardena1 := {}
  Cardena2 := {}
  Cardena3 := {}
  Cardena4 := {}

  For t=1 to nFaces

     NextToPaint := aPaintList[t]

     If nVertex_per_face == 4

        Cardena1 := aCoords_2d[aFaces[NextToPaint][1]]
        Cardena2 := aCoords_2d[aFaces[NextToPaint][2]]
        Cardena3 := aCoords_2d[aFaces[NextToPaint][3]]
        Cardena4 := aCoords_2d[aFaces[NextToPaint][4]]

        BT_DrawPolygon(hDC, {Cardena1[1], Cardena2[1], Cardena3[1], Cardena4[1]}, ;
			    {Cardena1[2], Cardena2[2], Cardena3[2], Cardena4[2]}, ;
		             BLACK, .1, YELLOW)
     else

        Cardena1 := aCoords_2d[aFaces[NextToPaint][1]]
        Cardena2 := aCoords_2d[aFaces[NextToPaint][2]]
        Cardena3 := aCoords_2d[aFaces[NextToPaint][3]]

        if aFaces[NextToPaint][1] >= 10
           Llena := YELLOW
           Lapiz := .12 
           Linea := ORANGE
        else
           Llena := RED
           Lapiz := .10 
           Linea := BLACK
        ENDIF

        BT_DrawPolygon(hDC, {Cardena1[1], Cardena2[1], Cardena3[1]}, ;
			    {Cardena1[2], Cardena2[2], Cardena3[2]}, ;
		             Linea, Lapiz, Llena)

	
     Endif

  Next

  BT_DeleteDC (BTstruct)

Return Nil
**********************
*
**********************
Function SinCosS()

	sYan = Round(Sin(Yan), 6)
	cYan = Round(Cos(Yan), 6)

	sXan = Round(Sin(Xan), 6)
	cXan = Round(Cos(Xan), 6)

	sZan = Round(Sin(Zan), 6)
	cZan = Round(Cos(Zan), 6)

Return Nil
**********************
*
**********************
Function de_3d_a_2d(aVector,aCoord,aRVectors)
Local x,y,z
local xx,yy,zz
local zSub


       x=aVector[1]
       y=aVector[2]
       z=aVector[3]

       xx = cXan*x-sXan*z
       zz = sXan*x+cXan*z
       x  = cYan*xx+sYan*y
       yy = cYan*y-sYan*xx
       z  = cZan*zz-sZan*yy
       y  = sZan*zz+cZan*yy

       aRVectors[1]=x
       aRVectors[2]=y
       aRVectors[3]=z

       x=x*278
       y=y*278

       zsub=z-Zoff;           // Translacion y proyeccion

       aCoord[1]=x/zsub+Xoff
       aCoord[2]=y/zsub+Yoff

Return Nil
**********************
*
**********************
Function Ordena_Z()
local p,s
local Z_Sub_Faces := Array(nFaces)
local aux

   For P = 1 To nFaces

      Z_Sub_Faces[p] = aRVectors[aFaces[p][1]][3]+;
		       aRVectors[aFaces[p][2]][3]+;
		       aRVectors[aFaces[p][3]][3]+;
		       iif(nVertex_per_Face=4,aRVectors[aFaces[p][4]][3],0)
	    aPaintList[p]=P

   Next

   For p = 0 To nFaces
	For S = 1 To nFaces-1
	   if  Z_Sub_Faces[s] > Z_Sub_Faces[s+1]
	      aux=Z_Sub_Faces[s+1]
	      Z_Sub_Faces[s+1] = Z_Sub_Faces[s]
	      Z_Sub_Faces[s] = aux
	      aux = aPaintList[s+1]
	      aPaintList[s+1] = aPaintList[s]
	      aPaintList[s] = aux
	   Endif
	Next
   Next

Return Nil
**********************
*
**********************
Function Newo1()

  yAn:=0.0
  xAn:=0.0
  zAn:=0.0

  sZoff:=-600
  sXoff:=0
  sYoff:=0

  AutoRotX:=.F.
  AutoRotY:=.F.
  AutoRotZ:=.F.

  RotX:=0.0
  RotY:=0.0
  RotZ:=0.0

*  sZoff:=0
*  sXoff:=0
*  sYoff:=0

  Zoff:=-225
  Xoff:=320
  Yoff:=240

  aVector_3d := {}
  aFaces     := {}

  aadd(aVector_3d,{-18,-18,-18})
  aadd(aVector_3d,{ 18,-18,-18})
  aadd(aVector_3d,{ 18, 18,-18})
  aadd(aVector_3d,{-18, 18,-18})
  aadd(aVector_3d,{-18,-18, 18})
  aadd(aVector_3d,{ 18,-18, 18})
  aadd(aVector_3d,{ 18, 18, 18})
  aadd(aVector_3d,{-18, 18, 18})

  aadd(aFaces,{1,4,3,2})
  aadd(aFaces,{8,7,6,5})
  aadd(aFaces,{5,8,4,1})
  aadd(aFaces,{6,7,3,2})
  aadd(aFaces,{5,1,2,6})
  aadd(aFaces,{8,4,3,7})

  Init_Data()

Return Nil
**********************
*
**********************
Function Newo2()

  yAn:=0.0
  xAn:=0.0
  zAn:=0.0

  sZoff:=-600
  sXoff:=0
  sYoff:=0

  AutoRotX:=.F.
  AutoRotY:=.F.
  AutoRotZ:=.F.

  RotX:=0.0
  RotY:=0.0
  RotZ:=0.0

*  sZoff:=0
*  sXoff:=0
*  sYoff:=0

  Zoff:=-300
  Xoff:=320
  Yoff:=240

  aVector_3d := {}
  aFaces     := {}

	aadd(aVector_3d,{   0,    0,   0})
	aadd(aVector_3d,{   0,    0,   0})
	aadd(aVector_3d,{   0,    0,   0})
	aadd(aVector_3d,{   0,    0,   0})
	aadd(aVector_3d,{ -27,   54,   0})
	aadd(aVector_3d,{   0,  -54,   0})
	aadd(aVector_3d,{  27,   54,   0})
	aadd(aVector_3d,{   0,   54, -27})
	aadd(aVector_3d,{   0,   54,  27})

	aadd(aVector_3d,{  27,   54,    0})
	aadd(aVector_3d,{   0,   54,   27})
	aadd(aVector_3d,{   0,   54,  -27})
	aadd(aVector_3d,{ -27,   54,    0})

	aadd(aFaces,{1,2,8})
	aadd(aFaces,{2,3,7})
	aadd(aFaces,{3,4,9})
	aadd(aFaces,{1,4,5})
	aadd(aFaces,{5,6,8})
	aadd(aFaces,{6,7,8})
	aadd(aFaces,{6,7,9})
	aadd(aFaces,{5,6,9})

	aadd(aFaces,{10,11,12})
	aadd(aFaces,{11,12,13})
	aadd(aFaces,{12,13,10})
	aadd(aFaces,{13,11,10})

  Init_Data()

Return Nil
**********************
*
**********************
Function Test_Visibilidad(nFace)
local Zt, rVal := .F.


	 ZT := aRVectors[aFaces [nFace][1] ][3]+;
	       aRVectors[aFaces [nFace][2] ][3]+;
	       aRVectors[aFaces [nFace][3] ][3]+;
	       aRVectors[aFaces [nFace][4] ][3]

	 If ZT < 0
	    rVal := .T.
	 Else
	    rVal := .F.
	 Endif

Return rVal
**********************
*
**********************
