#include "hmg.ch"

#define VIOLETA { 153,    0,  153 }
#define CELESTE { 180,  216,  252 }
#define ORANGE  { 225,  126,   54 }
#define PURPLE  { 126,    0,  126 }
#define GREYA   { 135,  135,  135 }
#define GREYB   { 216,  216,  216 }
#define GREYC   { 128,  128,  128 }
#define FUCHSIA { 252,    0,  252 }

Function Main()

   REQUEST DBFNTX
   RDDSETDEFAULT( "DBFNTX" )
   SET TOOLTIPSTYLE BALLOON
   SET TOOLTIPBACKCOLOR { 255 , 255, 0 }
   SET DATE BRITISH
   SET CENTURY ON
   SET CODEPAGE TO SPANISH
   SET DELETED OFF

   Publicar()

   DEFINE WINDOW oaSSisWatch ;
	AT 27, 27 ;
	WIDTH 447*Porc_Tam ;
	HEIGHT 486*Porc_Tam ; 
	TITLE "Cronmetro/Reloj - HMG 3.4.4 - CopyR 2017 oaSSis" ; 
	FONT "TAHOMA" SIZE Int(10*Porc_Tam) ;
        NOSIZE ;
        NOMAXIMIZE ;
        BACKCOLOR {244,164,96} ;
        ON PAINT Pintar() ;
        MAIN

     DEFINE BUTTON ButStopN
	ROW 410*Porc_Tam
        COL  10*Porc_Tam
        WIDTH  90*Porc_Tam
	HEIGHT  42*Porc_Tam
	FONTNAME "TAHOMA"
	FONTSIZE Int(9*Porc_Tam)
        FONTCOLOR BLUE
        CAPTION "Iniciar Cronmetro"
        VISIBLE .T.
	FLAT .F.
        TRANSPARENT .F.
	MULTILINE .T.
        ACTION PareN()  
     END BUTTON

     DEFINE BUTTON ButResetN
	ROW 410*Porc_Tam
        COL 100*Porc_Tam
        WIDTH  90*Porc_Tam
	HEIGHT  42*Porc_Tam
	FONTNAME "TAHOMA"
	FONTSIZE Int(9*Porc_Tam)
        FONTCOLOR BLUE
        CAPTION "Reiniciar Cronmetro"
        VISIBLE .T.
	FLAT .F.
        TRANSPARENT .F.
	MULTILINE .T.
        ACTION ResetN()  
     END BUTTON

     DEFINE BUTTON ButRelojN
	ROW 410*Porc_Tam
        COL 190*Porc_Tam
        WIDTH 90*Porc_Tam
	HEIGHT  42*Porc_Tam
	FONTNAME "TAHOMA"
	FONTSIZE Int(9*Porc_Tam)
        FONTCOLOR RED
        CAPTION "Pasar a Modo Reloj"
        VISIBLE .T.
	FLAT .F.
        TRANSPARENT .F.
	MULTILINE .T.
        ACTION RelojN()  
     END BUTTON
 
     DEFINE LABEL LabelTimeA
	ROW  418*Porc_Tam
        COL  (447*Porc_Tam)-144*Porc_Tam
        WIDTH  126*Porc_Tam
	HEIGHT  33*Porc_Tam
	FONTNAME "TAHOMA"
	FONTSIZE Int(18*Porc_Tam)
        FONTCOLOR BLUE
        VALUE Valor
        FONTBOLD .T.
        TRANSPARENT .T. 
        VISIBLE .T.
        ALIGNMENT Right
     END LABEL

     DEFINE TIMER TimerRelojA ;
        PARENT    oaSSisWatch ;
        INTERVAL  1000 ;
        ACTION    {|| VerLapsoA(), BT_ClientAreaInvalidateAll ("oaSSisWatch")}

     DEFINE TIMER TimerRelojB ;
        PARENT    oaSSisWatch ;
        INTERVAL  1000 ;
        ACTION    {|| VerLapsoB(), BT_ClientAreaInvalidateAll ("oaSSisWatch")}

   END WINDOW

   oaSSisWatch.Center

   oaSSisWatch.TimerRelojA.Enabled := .F.
   oaSSisWatch.TimerRelojB.Enabled := .F.

   oaSSisWatch.Activate

Return Nil
*************************
*
*************************
Procedure Publicar()

    Public VERSION        := " Version 1.0 - 2017 Beta "
    Public _RutaProg      := GetStartUpFolder() + '\'

    Public IniSegN 	  := 0
    Public IniSegB 	  := 0
    Public NStop          := .F.
    Public SegStopNi      := 0
    Public SegStopNf      := 0
    Public SegStopBi      := 0
    Public SegStopBf      := 0
    Public PrimeraPiN     := .T.
    Public PrimeraPiB     := .T.
    Public SegPasTim      := 0
    Public SegPasTam      := 0
    Public SegDaf         := 0
    Public Inicio         := .T.
    Public Valor          := "00:00:00"
    Public ValStop        := "00:00:00"
    Public AlReloj := .F.

    Public aVector_3d
    Public aFaces
    Public nFaces
    Public aPaintList
    Public aRVectors
    Public aCoords_2d
    Public nVertex_per_face
    Public lStop           := .F.
    Public yAn
    Public syAn
    Public cYan             // Angles
    Public xAn
    Public sXAn
    Public cXan             //   ""    (los 3 en radianes)
    Public zAn
    Public szAn
    Public cZan             //   ""

    Public sZoff                      // Desplazamiento inicial Z
    Public sXoff                      // Desplazamineto inicial X (las 3 2d)
    Public sYoff                      // Desplazamineto inicial Y

    Public Zoff                       // desplazamineto de z
    Public Xoff                       // desplazamineto de x
    Public Yoff                       // desplazamineto de y

    Public aVector_3dM
    Public aFacesM
    Public nFacesM
    Public aPaintListM
    Public aRVectorsM
    Public aCoords_2dM
    Public nVertex_per_faceM
    Public lStopM           := .F.
    Public yAnM
    Public syAnM
    Public cYanM            // Angles
    Public xAnM
    Public sXAnM
    Public cXanM             //   ""    (los 3 en radianes)
    Public zAnM
    Public szAnM
    Public cZanM             //   ""

    Public sZoffM                      // Desplazamiento inicial Z
    Public sXoffM                      // Desplazamineto inicial X (las 3 2d)
    Public sYoffM                      // Desplazamineto inicial Y

    Public ZoffM                       // desplazamineto de z
    Public XoffM                       // desplazamineto de x
    Public YoffM                       // desplazamineto de y

    Public aVector_3dH
    Public aFacesH
    Public nFacesH
    Public aPaintListH
    Public aRVectorsH
    Public aCoords_2dH
    Public nVertex_per_faceH
    Public yAnH
    Public syAnH
    Public cYanH            // Angles
    Public xAnH
    Public sXAnH
    Public cXanH             //   ""    (los 3 en radianes)
    Public zAnH
    Public szAnH
    Public cZanH             //   ""

    Public sZoffH                      // Desplazamiento inicial Z
    Public sXoffH                      // Desplazamineto inicial X (las 3 2d)
    Public sYoffH                      // Desplazamineto inicial Y

    Public ZoffH                       // desplazamineto de z
    Public XoffH                       // desplazamineto de x
    Public YoffH                       // desplazamineto de y

    Public Porc_Tam       := 1

    Newo()

Return
**********************
*
**********************
Function ResetN()

	IniSegN        := 0
	IniSegB        := 0
	NStop          := .F.
	SegStopNi      := 0
	SegStopNf      := 0
	SegStopBi      := 0
	SegStopBf      := 0
	PrimeraPiN     := .T.
	PrimeraPiB     := .T.
	SegPasTim      := 0
	SegPasTam      := 0
	SegDaf         := 0
	Inicio         := .T.
	Valor          := "00:00:00"

        Newo()

        oaSSisWatch.ButStopN.Caption := "Iniciar Cronmetro"
        oaSSisWatch.TimerRelojA.Enabled := .F.
        oaSSisWatch.LabelTimeA.Value := Valor
        oaSSisWatch.LabelTimeA.Fontcolor := BLUE
        oaSSisWatch.TimerRelojB.Enabled := .F.

        BT_ClientAreaInvalidateAll ("oaSSisWatch")

Return
**********************
*
**********************
Function GradToRad(grados)
Return (Grados*3.1416)/180
**********************
*
**********************
Procedure Pintar()
LOCAL ssWidth  := BT_ClientAreaWidth  ("oaSSisWatch") 
LOCAL ssHeight := BT_ClientAreaHeight ("oaSSisWatch") - 54 * Porc_Tam
Local t, x, w, Corde_xA, Corde_xB, Corde_yA, Corde_yB
Local Cardena1, Cardena2, Cardena3
LOCAL hDC, BTstruct

  hDC := BT_CreateDC ("oaSSisWatch", BT_HDC_INVALIDCLIENTAREA, @BTstruct)

  BT_DrawGradientFillVertical (hDC,  0,  0,  ssWidth,  ssHeight, WHITE, BLUE)                 

  BT_DrawFillEllipse(hDC, 22*Porc_Tam, 22*Porc_Tam, 395*Porc_Tam, 357*Porc_Tam, {220,220,220}, BLACK, 1.2)
  BT_DrawFillEllipse(hDC, 30*Porc_Tam, 50*Porc_Tam, 340*Porc_Tam, 340*Porc_Tam, {255,228,181}, BLACK, 1.2)
  BT_DrawFillEllipse(hDC, 40*Porc_Tam, 60*Porc_Tam, 320*Porc_Tam, 320*Porc_Tam, CELESTE, BLACK, 1.2)

  For w = 0 to 59

     wXan  := 0
     wYan  := Round(GradToRad(w*6), 4)

     wsYan := Round(Sin(wYan),6)
     wcYan := Round(Cos(wYan),6)

     wsXan = Round(Sin(wXan),6)
     wcXan = Round(Cos(wXan),6)

     wx := -159*Porc_Tam
     wy := -1
     wxx := wcXan * wx
     wx  := wcYan * wxx + wsYan * wy
     wyy := wcYan * wy - wsYan * wxx
     wy  := wyy

     Corde_xB := wx + Xoff
     Corde_yB := wy + Yoff

     wx := -149*Porc_Tam
     wy := -1
     wxx := wcXan * wx
     wx  := wcYan * wxx + wsYan * wy
     wyy := wcYan * wy - wsYan * wxx
     wy  := wyy

     Corde_xA := wx + Xoff
     Corde_yA := wy + Yoff

     if w == 0 .or. w/5 == int(w/5)

        if w == 15 .or. w == 30 .or. w == 45 .or. w == 0

           wx := -141*Porc_Tam
           wy := -1
           wxx := wcXan * wx
           wx  := wcYan * wxx + wsYan * wy
           wyy := wcYan * wy - wsYan * wxx
           wy  := wyy

           Corde_xA := wx + Xoff
           Corde_yA := wy + Yoff

           BT_DrawLine(hDC, Corde_xA, Corde_yA, Corde_xB, Corde_yB, ;
                    BLACK, 3.5*Porc_Tam)

        else

           wx := -144*Porc_Tam
           wy := -1
           wxx := wcXan * wx
           wx  := wcYan * wxx + wsYan * wy
           wyy := wcYan * wy - wsYan * wxx
           wy  := wyy

           Corde_xA := wx + Xoff
           Corde_yA := wy + Yoff

           BT_DrawLine(hDC, Corde_xA, Corde_yA, Corde_xB, Corde_yB, ;
                       BLACK, 3*Porc_Tam)
 
        endif

     else

        wx := -149*Porc_Tam
        wy := -1
        wxx := wcXan * wx
        wx  := wcYan * wxx + wsYan * wy
        wyy := wcYan * wy - wsYan * wxx
        wy  := wyy

        Corde_xA := wx + Xoff
        Corde_yA := wy + Yoff

        BT_DrawLine(hDC, Corde_xA, Corde_yA, Corde_xB, Corde_yB, ;
                 BLACK, 1.2*Porc_tam)

     endif

  next

  SinCosH()

  For T=1 to Len(aVector_3dH)
     de_3d_a_2dH(aVector_3dH[T],aCoords_2dH[T],aRVectorsH[T])
  Next

  Ordena_ZH()

  Cardena1 := {}
  Cardena2 := {}
  Cardena3 := {}

  For t=1 to nFacesH

     NextToPaintH := aPaintListH[t]

     Cardena1 := aCoords_2dH[aFacesH[NextToPaintH][1]]
     Cardena2 := aCoords_2dH[aFacesH[NextToPaintH][2]] 
     Cardena3 := aCoords_2dH[aFacesH[NextToPaintH][3]] 

     BT_DrawPolygon(hDC, {Cardena1[1], Cardena2[1], Cardena3[1]}, ;
			 {Cardena1[2], Cardena2[2], Cardena3[2]}, ;
		          BLACK, .21, GREYC)

  Next

  SinCosM()

  For T=1 to Len(aVector_3dM)
     de_3d_a_2dM(aVector_3dM[T],aCoords_2dM[T],aRVectorsM[T])
  Next

  Ordena_ZM()

  Cardena1 := {}
  Cardena2 := {}
  Cardena3 := {}

  For t=1 to nFacesM

     NextToPaintM := aPaintListM[t]

     Cardena1 := aCoords_2dM[aFacesM[NextToPaintM][1]]
     Cardena2 := aCoords_2dM[aFacesM[NextToPaintM][2]] 
     Cardena3 := aCoords_2dM[aFacesM[NextToPaintM][3]] 

     BT_DrawPolygon(hDC, {Cardena1[1], Cardena2[1], Cardena3[1]}, ;
			 {Cardena1[2], Cardena2[2], Cardena3[2]}, ;
		          PURPLE, .14, ORANGE)

  Next

  SinCosS()

  For T=1 to Len(aVector_3d)
     de_3d_a_2d(aVector_3d[T],aCoords_2d[T],aRVectors[T])
  Next

  Ordena_Z()

  Cardena1 := {}
  Cardena2 := {}
  Cardena3 := {}

  For t=1 to nFaces

     NextToPaint := aPaintList[t]

     Cardena1 := aCoords_2d[aFaces[NextToPaint][1]]
     Cardena2 := aCoords_2d[aFaces[NextToPaint][2]] 
     Cardena3 := aCoords_2d[aFaces[NextToPaint][3]] 

     BT_DrawPolygon(hDC, {Cardena1[1], Cardena2[1], Cardena3[1]}, ;
			 {Cardena1[2], Cardena2[2], Cardena3[2]}, ;
		         BLACK, .07, YELLOW)

  Next

  BT_DrawFillEllipse(hDC, 190*Porc_Tam, 210*Porc_Tam, 20*Porc_Tam, 20*Porc_Tam, WHITE, BLACK, .18)

  BT_DeleteDC (BTstruct)

Return
**********************
*
**********************
Function SinCosM()

	sYanM = Round(Sin(YanM), 6)
	cYanM = Round(Cos(YanM), 6)

	sXanM = Round(Sin(XanM), 6)
	cXanM = Round(Cos(XanM), 6)

	sZanM = Round(Sin(ZanM), 6)
	cZanM = Round(Cos(ZanM), 6)

Return Nil
**********************
*
**********************
Function SinCosH()

	sYanH = Round(Sin(YanH), 6)
	cYanH = Round(Cos(YanH), 6)

	sXanH = Round(Sin(XanH), 6)
	cXanH = Round(Cos(XanH), 6)

	sZanH = Round(Sin(ZanH), 6)
	cZanH = Round(Cos(ZanH), 6)

Return Nil
**********************
*
**********************
Function SinCosS()

	sYan = Round(Sin(Yan), 6)
	cYan = Round(Cos(Yan), 6)

	sXan = Round(Sin(Xan), 6)
	cXan = Round(Cos(Xan), 6)

	sZan = Round(Sin(Zan), 6)
	cZan = Round(Cos(Zan), 6)

Return Nil
**********************
*
**********************
Function Newo()

  yAn:=0.0
  xAn:=0.0
  zAn:=0.0

  sZoff:=0
  sXoff:=0
  sYoff:=0

  Zoff:=-180*Porc_Tam
  Xoff:=200*Porc_Tam
  Yoff:=220*Porc_Tam

  aVector_3d := {}
  aFaces     := {}

  yAnM:=0.0
  xAnM:=0.0
  zAnM:=0.0

  sZoffM:=0
  sXoffM:=0
  sYoffM:=0

  ZoffM:=-180*Porc_Tam
  XoffM:=200*Porc_Tam
  YoffM:=220*Porc_Tam

  aVector_3dM := {}
  aFacesM     := {}

  yAnH:=0.0
  xAnH:=0.0
  zAnH:=0.0

  sZoffH:=0
  sXoffH:=0
  sYoffH:=0

  ZoffH:=-180*Porc_Tam
  XoffH:=200*Porc_Tam
  YoffH:=220*Porc_Tam

  aVector_3dH := {}
  aFacesH     := {}
			       //x   y   z
  aadd(aVector_3d,{   0,   -3,   0})
  aadd(aVector_3d,{-135,   -1,   0})
  aadd(aVector_3d,{  -1,    3,   0})

  aadd(aFaces,{1,2,3})
  aadd(aFaces,{3,2,1})

  aadd(aVector_3dM,{   0,   -5,   0})
  aadd(aVector_3dM,{-115,   -1,   0})
  aadd(aVector_3dM,{  -1,    5,   0})

  aadd(aFacesM,{1,2,3})
  aadd(aFacesM,{3,2,1})

  aadd(aVector_3dH,{   0,   -7,   0})
  aadd(aVector_3dH,{ -90,   -1,   0})
  aadd(aVector_3dH,{  -1,    7,   0})

  aadd(aFacesH,{1,2,3})
  aadd(aFacesH,{3,2,1})

  nFaces := Len(aFaces)
  aPaintList := Array(nFaces)

  aRVectors  := Array(Len(aVector_3d),3)
  aCoords_2d := Array(Len(aVector_3d),2)
  nVertex_per_face := Len(aFaces[1])

  nFacesM := Len(aFacesM)
  aPaintListM := Array(nFacesM)

  aRVectorsM  := Array(Len(aVector_3dM),3)
  aCoords_2dM := Array(Len(aVector_3dM),2)
  nVertex_per_faceM := Len(aFacesM[1])

  nFacesH := Len(aFacesH)
  aPaintListH := Array(nFacesH)

  aRVectorsH  := Array(Len(aVector_3dH),3)
  aCoords_2dH := Array(Len(aVector_3dH),2)
  nVertex_per_faceH := Len(aFacesH[1])

Return Nil
**********************
*
**********************
Function de_3d_a_2dM(aVectorM,aCoordM,aRVectorsM)
Local x,y,z
local xx,yy,zz
local zSub


       x=aVectorM[1]
       y=aVectorM[2]
       z=aVectorM[3]

       xx = cXanM*x-sXanM*z
       zz = sXanM*x+cXanM*z
       x  = cYanM*xx+sYanM*y
       yy = cYanM*y-sYanM*xx
       z  = cZanM*zz-sZanM*yy
       y  = sZanM*zz+cZanM*yy

       aRVectorsM[1]=x
       aRVectorsM[2]=y
       aRVectorsM[3]=z

       x=x*180
       y=y*180

       zsub=z-ZoffM;           // Translacion y proyeccion

       aCoordM[1]=x/zsub+XoffM
       aCoordM[2]=y/zsub+YoffM

Return Nil
**********************
*
**********************
Function de_3d_a_2d(aVector,aCoord,aRVectors)
Local x,y,z
local xx,yy,zz
local zSub


       x=aVector[1]
       y=aVector[2]
       z=aVector[3]

       xx = cXan*x-sXan*z
       zz = sXan*x+cXan*z
       x  = cYan*xx+sYan*y
       yy = cYan*y-sYan*xx
       z  = cZan*zz-sZan*yy
       y  = sZan*zz+cZan*yy

       aRVectors[1]=x
       aRVectors[2]=y
       aRVectors[3]=z

       x=x*180
       y=y*180

       zsub=z-Zoff;           // Translacion y proyeccion

       aCoord[1]=x/zsub+Xoff
       aCoord[2]=y/zsub+Yoff

Return Nil
**********************
*
**********************
Function de_3d_a_2dH(aVectorH,aCoordH,aRVectorsH)
Local x,y,z
local xx,yy,zz
local zSub


       x=aVectorH[1]
       y=aVectorH[2]
       z=aVectorH[3]

       xx = cXanH*x-sXanH*z
       zz = sXanH*x+cXanH*z
       x  = cYanH*xx+sYanH*y
       yy = cYanH*y-sYanH*xx
       z  = cZanH*zz-sZanH*yy
       y  = sZanH*zz+cZanH*yy

       aRVectorsH[1]=x
       aRVectorsH[2]=y
       aRVectorsH[3]=z

       x=x*180
       y=y*180

       zsub=z-ZoffH;           // Translacion y proyeccion

       aCoordH[1]=x/zsub+XoffH
       aCoordH[2]=y/zsub+YoffH

Return Nil
**********************
*
**********************
Function Ordena_Z()
local p,s
local Z_Sub_Faces := Array(nFaces)
local aux

   For P = 1 To nFaces

      Z_Sub_Faces[p] = aRVectors[aFaces[p][1]][3]+;
		       aRVectors[aFaces[p][2]][3]+;
		       aRVectors[aFaces[p][3]][3]+;
		       iif(nVertex_per_Face=4,aRVectors[aFaces[p][4]][3],0)
	    aPaintList[p]=P

   Next

   For p = 0 To nFaces
	For S = 1 To nFaces-1
	   if  Z_Sub_Faces[s] > Z_Sub_Faces[s+1]
	      aux=Z_Sub_Faces[s+1]
	      Z_Sub_Faces[s+1] = Z_Sub_Faces[s]
	      Z_Sub_Faces[s] = aux
	      aux = aPaintList[s+1]
	      aPaintList[s+1] = aPaintList[s]
	      aPaintList[s] = aux
	   Endif
	Next
   Next

Return Nil
**********************
*
**********************
Function Ordena_ZH()
local p,s
local Z_Sub_Faces := Array(nFacesH)
local aux

   For P = 1 To nFacesH

      Z_Sub_Faces[p] = aRVectorsH[aFacesH[p][1]][3]+;
		       aRVectorsH[aFacesH[p][2]][3]+;
		       aRVectorsH[aFacesH[p][3]][3]+;
		       iif(nVertex_per_FaceH=4,aRVectorsH[aFacesH[p][4]][3],0)
	    aPaintListH[p]=P

   Next

   For p = 0 To nFacesH
	For S = 1 To nFacesH-1
	   if  Z_Sub_Faces[s] > Z_Sub_Faces[s+1]
	      aux=Z_Sub_Faces[s+1]
	      Z_Sub_Faces[s+1] = Z_Sub_Faces[s]
	      Z_Sub_Faces[s] = aux
	      aux = aPaintListH[s+1]
	      aPaintListH[s+1] = aPaintListH[s]
	      aPaintListH[s] = aux
	   Endif
	Next
   Next

Return Nil
**********************
*
**********************
Function Ordena_ZM()
local p,s
local Z_Sub_Faces := Array(nFacesM)
local aux

   For P = 1 To nFacesM

      Z_Sub_Faces[p] = aRVectorsM[aFacesM[p][1]][3]+;
		       aRVectorsM[aFacesM[p][2]][3]+;
		       aRVectorsM[aFacesM[p][3]][3]+;
		       iif(nVertex_per_FaceM=4,aRVectorsM[aFacesM[p][4]][3],0)
	    aPaintListM[p]=P

   Next

   For p = 0 To nFacesM
	For S = 1 To nFacesM-1
	   if  Z_Sub_Faces[s] > Z_Sub_Faces[s+1]
	      aux=Z_Sub_Faces[s+1]
	      Z_Sub_Faces[s+1] = Z_Sub_Faces[s]
	      Z_Sub_Faces[s] = aux
	      aux = aPaintListM[s+1]
	      aPaintListM[s+1] = aPaintListM[s]
	      aPaintListM[s] = aux
	   Endif
	Next
   Next

Return Nil
**********************
*
**********************
Function RelojN()
Local QueHago 

   QueHago := oaSSisWatch.ButRelojN.Caption

   if QueHago == "Pasar a Modo Reloj"
      AlReloj := .T.
      oaSSisWatch.TimerRelojB.Enabled := .T.
      oaSSisWatch.ButStopN.Enabled := .F.
      oaSSisWatch.ButRelojN.Caption := "Pasar a Modo Cronmetro"
      oaSSisWatch.ButResetN.Enabled := .F.

      TimeMaq := Time()
      HorPasC := Substr(TimeMaq, 1, 2) 	
      MinPasC := Substr(TimeMaq, 4, 2) 	 
      SegPasC := Substr(TimeMaq, 7, 2) 
      HorPasN := Val(HorPasC)
      MinPasN := Val(MinPasC)
      SegPasN := Val(SegPasC)

      Valor := HorPasC+":"+MinPasC+":"+SegPasC

      oaSSisWatch.LabelTimeA.Value := Valor
      oaSSisWatch.LabelTimeA.Fontcolor := RED

      yAn  := Round(GradToRad(SegPasN*6), 4)
      yAnM := Round(GradToRad(MinPasN*6), 4)
      yAnH := Round(GradToRad(HorPasN*30),4)

      if yAn < 0 .or. yAn >= 6.28
         Yan := 0
      endif

      if yAnM < 0 .or. yAnM >= 6.28
         YanM := 0
      endif

      if yAnH < 0 .or. yAnH >= 6.28
        YanH := 0
      endif

      BT_ClientAreaInvalidateAll ("oaSSisWatch")

   else

      AlReloj := .F.
      oaSSisWatch.TimerRelojB.Enabled := .F.
      oaSSisWatch.ButRelojN.Caption := "Pasar a Modo Reloj"
      oaSSisWatch.ButStopN.Enabled := .T.
      oaSSisWatch.ButResetN.Enabled := .T.
      oaSSisWatch.LabelTimeA.Fontcolor := BLUE

      if ValStop <> "00:00:00"

   	HorPasC := Substr(ValStop, 1, 2) 	
   	MinPasC := Substr(ValStop, 4, 2) 	 
   	SegPasC := Substr(ValStop, 7, 2) 
   	HorPasN := Val(HorPasC)
   	MinPasN := Val(MinPasC)
   	SegPasN := Val(SegPasC)

   	Valor := HorPasC+":"+MinPasC+":"+SegPasC

        oaSSisWatch.LabelTimeA.Value := Valor
        ValStop := "00:00:00"

        yAn  := Round(GradToRad(SegPasN*6), 4)
        yAnM := Round(GradToRad(MinPasN*6), 4)

   	if yAn < 0 .or. yAn >= 6.28
   	   Yan := 0
   	endif

	if yAnM < 0 .or. yAnM >= 6.28
      	   YanM := 0
        endif

        yAnH := Round(GradToRad(HorPasN*30), 4)
   
        if yAnH < 0 .or. yAnH >= 6.28
           YanH := 0
        endif

        BT_ClientAreaInvalidateAll ("oaSSisWatch")

      Endif

   endif
       
Return
**********************
*
**********************
Function VerLapsoA()
Local SegPas, HorPasN, HorPasC, MinPasN, MinPasC, SegDif, TodaHora
Local SegPasN, SegPasC, MinPasN0, AriYan := Array(3)

   if Inicio == .T.
      Return
   endif	

   if AlReloj == .F.

   SegDif := 0

   if SegStopNf > 0 .and. SegStopNi > 0
      SegDif := SegStopNf - SegStopNi
      if SegDif < 1
         SegDif := 0
      endif
   endif 
   if SegDif > 0
      IniSegN += SegDif
      SegStopNf := 0
      SegStopNi := 0
      SegDif := 0
      SegDaf := 0
   endif 

   SegPas :=  Seconds() - IniSegN
   SegPas += SegDaf
   MilPasN := 0
   HorPasN := 0
   MinPasN := 0
   SegPasN := 0
   TodaHora := 0

   HorPasN  := Int(SegPas/3600)
   TodaHora := SegPas/3600
   HorPasC  := StrZero(HorPasN, 2)
   Quedan   := (TodaHora - HorPasN)*3600
   MinPasN0 := quedan/60
   MinPasN  := Int(Quedan/60)
   MinPasC  := StrZero(MinPasN, 2)
   SegPasN  := Int((MinPasN0 - MinPasN)*60)
   SegPasC  := StrZero(SegPasN, 2)

   SegPasTim := SegPasN

   Valor := HorPasC+":"+MinPasC+":"+SegPasC

   oaSSisWatch.LabelTimeA.Value := Valor

   yAn  := Round(GradToRad(SegPasN*6), 4)
   yAnM := Round(GradToRad(MinPasN*6), 4)

   if yAn < 0 .or. yAn >= 6.28
      Yan := 0
   endif

   if yAnM < 0 .or. yAnM >= 6.28
      YanM := 0
   endif

   if TodaHora > 0.02
      yAnH := Round(GradToRad(TodaHora*30), 4)
   else
      YanH := 0
   endif
   
   if yAnH < 0 .or. yAnH >= 6.28
      YanH := 0
   endif

   Endif

Return
**********************
*
**********************
Function VerLapsoB()

   TimeMaq := Time()
   HorPasC := Substr(TimeMaq, 1, 2) 	
   MinPasC := Substr(TimeMaq, 4, 2) 	 
   SegPasC := Substr(TimeMaq, 7, 2) 
   HorPasN := Val(HorPasC)
   MinPasN := Val(MinPasC)
   SegPasN := Val(SegPasC)

   Valor := HorPasC+":"+MinPasC+":"+SegPasC

   oaSSisWatch.LabelTimeA.Value := Valor

   yAn  := Round(GradToRad(SegPasN*6), 4)
   yAnM := Round(GradToRad(MinPasN*6), 4)
   yAnH := Round(GradToRad(HorPasN*30),4)

   if yAn < 0 .or. yAn >= 6.28
      Yan := 0
   endif

   if yAnM < 0 .or. yAnM >= 6.28
      YanM := 0
   endif

  if yAnH < 0 .or. yAnH >= 6.28
     YanH := 0
  endif

**********************
*
**********************
Function PareN()
Local Tratra := oaSSisWatch.ButStopN.Caption

if TraTra == "Iniciar Cronmetro"
   oaSSisWatch.TimerRelojA.Enabled := .T.
   IniSegN := Seconds()
   oaSSisWatch.ButStopN.Caption := "STOP Cronmetro"
   NStop := .F.
   Inicio := .F.
   ValStop := "00:00:00"
else
   if NStop == .F.
      NStop := .T.
      oaSSisWatch.ButStopN.Caption := "Continuar Cronmetro"
      SegStopNi := Seconds()-IniSegN
      oaSSisWatch.TimerRelojA.Enabled := .F.
      ValStop := Valor 
   ELSE
      NStop := .F.
      oaSSisWatch.ButStopN.Caption := "STOP Cronmetro"
      SegStopNf := Seconds()-IniSegN
      oaSSisWatch.TimerRelojA.Enabled := .T.
      ValStop := "00:00:00"
   endif
endif

Return
**************************************************
*
**************************************************


